// red2.h - Definicija klase redova ogranicenih kapaciteta.

/**
Implementira se kao kruzni bafer.
*/
#ifndef red2_h
#define red2_h

class Red {
  int *niz, kap, duz, prvi, posl; // polja klase
  static int broj_obj;
public:
  explicit Red (int k=10);      // Stvaranje praznog reda (nije konverzija).
  Red (const Red& rd);          // Stvaranje reda od kopije drugog.
  inline ~Red () { delete [] niz; }                // Unistavanje reda. - inline f-ja
  void stavi (int b);                       // Stavljanje broja u red.
  int uzmi ();                              // Uzimanje broja iz reda.
  inline bool prazan () const { return duz == 0; } // Da li je red prazan? - inline f-ja
  inline bool pun () const { return duz == kap; }  // Da li je red pun? - inline f-ja
  void pisi () const ;	                   // Pisanje sadrzaja reda.
  inline void prazni () { duz = prvi = posl = 0; } // Praznjenje reda. - inline f-ja
  int no_obj () { return broj_obj; } // Koliko objekata klase ima? - inline f-ja
  static int no_obj1 () { return broj_obj; } // Koliko objekata klase ima? - inline f-ja 
  friend int no_obj2 (Red obj) { return obj.broj_obj; } // Koliko objekata klase ima? - inline f-ja
};

#endif
