// red2t.C - Ispitivanje klase redova ogranicenih kapacieta.

#include "red2.h"
#include <iostream>
using namespace std;
//int Red::broj_obj=0; // Inicijalizacija statickog polja uvek pre main()
					   //	nikada u telu ili metodama klase

int main () {
  bool kraj = false;	
  // Primeri razlicitih konstrura	 
  Red* rd = new Red (5); // Konstruktor sa parametrima
  // Red r1 = 3;   // Ne moze, jer je konstruktor konverzije izmenjen da bude explicit. 
  Red r1 = static_cast <Red> (3); // Ovako moze
  Red r2(r1); // Konstruktor kopije - moglo je i Red r2 = r1;
  Red r3; // podrazumevani konstruktor
  
  // Operator dodele je definisan za svaku klasu
  r3=r2; // Sta ce se inicijalizovati kako treba ?

  // Ispis broja kreiranih objekata
  //cout << Red::broj_obj; // Ovako ne moze jer je polje iako staticko private 
  cout << "Broj kreiranih objekata do sada je:" << endl;
  cout << r1.no_obj() << endl; // Realiyacija preko metode klase
  cout << Red::no_obj1() <<endl; // Realizacija preko staticke metode
  cout << no_obj2(r1) << endl; // Realizacija preko prijateljske metode
  cout << no_obj2(r1) << endl; // Sta se desilo ?

  // Dinamicko alociranja i brisanja memorije
  Red* rd1 = new Red (5); // Konstruktor sa parametrima
  Red rd11 = *(new Red(5)); // Konstruktor sa parametrima
  delete rd1;
  char* str2 = new char[20]; // alociranje 20 karaktera
  str2 = strcpy(str2,"Marko \"Markovic\""); // Dodela
  delete [] str2; // Nizovi objekata se brisu uvek pomocu []

  // Test
  while (! kraj) {
    cout << "\n1. Stavaranje reda\n"
              "2. Stavljanje podatka u red\n"
              "3. Uzimanje podatka iz reda\n"
              "4. Ispisivanje sadrzaja reda\n"
              "5. Praznjenje reda\n"
              "0. Zavrsetak rada\n\n"
              "Vas izbor? ";
    int izbor; cin >> izbor;
    switch (izbor) {
    case 1: // Stvaranje novog reda:
      cout << "Kapacitet? "; int k; cin >> k;
      if (k > 0) { delete rd; rd = new Red (k); }
        else cout << "*** Nedozvoljeni kapacitet! ***\a\n";
      break;
    case 2: // Stavljanje podatka u red:
      if (! rd->pun ()) {
        cout << "Broj?      "; int b; cin >> b; rd->stavi (b);
      } else cout << "*** Red je pun! ***\a\n";
      break;
    case 3: // Uzimanje podatka iz reda:
      if (! rd->prazan ())
        cout << "Broj=      " << rd->uzmi () << endl;
      else cout << "*** Red je prazan! ***\a\n";
      break;

    case 4: // Ispisivanje sadrzaja reda:
      cout << "Red=       "; rd->pisi (); cout << endl;
      break;
    case 5: // Praznjenje reda:
      rd->prazni (); break;
    case 0: // Zavrsetak rada:
      kraj = true; break;
    default: // Pogresan izbor:
      cout << "*** Nedozvoljen izbor! ***\a\n"; break;
    }
  }
  return 0; // Destruktori za svaki objekat (staticki ili dinamicki) 
			// se pozivaju implicitno pri izlasku iz programa
}
